using System;
using InABox.Core;

namespace InABox.Mobile
{
    public interface IDetailModel : IModel
    {
        
    }
    
    public interface IDetailModel<TParent, TItem, in TEntity> : IDetailModel
        where TParent : IDetailModel
        where TItem : Shell<TParent, TEntity>, new()
        where TEntity : Entity, IRemotable, IPersistent, new() 
    {
        TItem Item { get; set; }
        
        void BeforeLoad(MultiQuery query);
        
        void AfterLoad(MultiQuery query);
        
        void Load(Action loaded = null);
        
        void Load(TEntity entity, Action loaded = null);
    }
}